aboutsummaryrefslogtreecommitdiffhomepage
path: root/src/test
diff options
context:
space:
mode:
authorGravatar David Ostrovsky <david@ostrovsky.org>2017-09-25 03:55:01 -0400
committerGravatar John Cater <jcater@google.com>2017-09-25 09:39:09 -0400
commit82859b0c969f84fe49ec7fd1c8702461e847890c (patch)
tree22274d8f273682b9e88b8d348f3324bd44d33491 /src/test
parent824db7f592f422d5056b3935cf1c71a8b96fe4ac (diff)
Internal change
PiperOrigin-RevId: 169874059
Diffstat (limited to 'src/test')
-rw-r--r--src/test/shell/bazel/BUILD7
-rw-r--r--src/test/shell/bazel/local_action_cache_test.sh69
2 files changed, 76 insertions, 0 deletions
diff --git a/src/test/shell/bazel/BUILD b/src/test/shell/bazel/BUILD
index 6e367a7489..d78befae85 100644
--- a/src/test/shell/bazel/BUILD
+++ b/src/test/shell/bazel/BUILD
@@ -280,6 +280,13 @@ sh_test(
)
sh_test(
+ name = "local_action_cache_test",
+ size = "small",
+ srcs = ["local_action_cache_test.sh"],
+ data = [":test-deps"],
+)
+
+sh_test(
name = "runfiles_test",
size = "medium",
srcs = ["runfiles_test.sh"],
diff --git a/src/test/shell/bazel/local_action_cache_test.sh b/src/test/shell/bazel/local_action_cache_test.sh
new file mode 100644
index 0000000000..60c9c4ecc1
--- /dev/null
+++ b/src/test/shell/bazel/local_action_cache_test.sh
@@ -0,0 +1,69 @@
+#!/bin/bash
+#
+# Copyright 2017 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# Test the local action cache
+#
+
+# Load the test setup defined in the parent directory
+CURRENT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+source "${CURRENT_DIR}/../integration_test_setup.sh" \
+ || { echo "integration_test_setup.sh not found!" >&2; exit 1; }
+
+function test_local_action_cache() {
+ local cache="${TEST_TMPDIR}/cache"
+ local execution_file="${TEST_TMPDIR}/run.log"
+ local input_file="foo.in"
+ local output_file="bazel-genfiles/foo.txt"
+ local flags="--experimental_local_disk_cache_path=$cache --experimental_local_disk_cache"
+
+ rm -rf $cache
+ mkdir $cache
+
+ touch WORKSPACE
+ # No sandboxing, side effect is needed to detect action execution
+ cat > BUILD <<EOF
+genrule(
+ name = "foo",
+ cmd = "echo run > $execution_file && cat \$< >\$@",
+ srcs = ["$input_file"],
+ outs = ["foo.txt"],
+ tags = ["local"],
+)
+EOF
+
+ # CAS is empty, cache miss
+ echo 0 >"${execution_file}"
+ echo 1 >"${input_file}"
+ bazel build $flags :foo &> $TEST_log || fail "Build failed"
+ assert_equals "1" $(cat "${output_file}")
+ assert_equals "run" $(cat "${execution_file}")
+
+ # CAS doesn't have output for this input, cache miss
+ echo 0 >"${execution_file}"
+ echo 2 >"${input_file}"
+ bazel build $flags :foo &> $TEST_log || fail "Build failed"
+ assert_equals "2" $(cat "${output_file}")
+ assert_equals "run" $(cat "${execution_file}")
+
+ # Cache hit, no action run/no side effect
+ echo 0 >"${execution_file}"
+ echo 1 >"${input_file}"
+ bazel build $flags :foo &> $TEST_log || fail "Build failed"
+ assert_equals "1" $(cat "${output_file}")
+ assert_equals "0" $(cat "${execution_file}")
+}
+
+run_suite "local action cache test"